package com.friday.custody.service.basicService.impl;

import com.friday.custody.entity.DataDictionaryHandleTypeDetailsEntity;
import com.friday.custody.enums.DataDictionaryTypeEnum;
import com.friday.custody.service.basicService.DataDictionaryHandleTypeDetailsService;
import com.friday.custody.service.logicService.DataDictionaryBasicService;
import com.friday.custody.utils.R;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.friday.custody.utils.PageUtils;
import com.friday.custody.utils.Query;

import com.friday.custody.dao.DataDictionaryHandleTypeDao;
import com.friday.custody.entity.DataDictionaryHandleTypeEntity;
import com.friday.custody.service.basicService.DataDictionaryHandleTypeService;
import org.springframework.util.CollectionUtils;


@Service("dataDictionaryHandleTypeService")
public class DataDictionaryHandleTypeServiceImpl extends ServiceImpl<DataDictionaryHandleTypeDao, DataDictionaryHandleTypeEntity>
        implements DataDictionaryHandleTypeService, DataDictionaryBasicService {

    @Override
    public PageUtils queryPage(Map<String, Object> params) {
        IPage<DataDictionaryHandleTypeEntity> page = this.page(
                new Query<DataDictionaryHandleTypeEntity>().getPage(params),
                new QueryWrapper<DataDictionaryHandleTypeEntity>()
        );

        return new PageUtils(page);
    }

    @Autowired
    private DataDictionaryHandleTypeDetailsService detailsService;
    @Override
    public Map<String, String> queryWithDetail(String trustNo) {
        HashMap<String, String> result = new HashMap<>();
        List<DataDictionaryHandleTypeEntity> allDatas = baseMapper.selectList(new QueryWrapper<>());
        if (!CollectionUtils.isEmpty(allDatas)) {
            List<DataDictionaryHandleTypeDetailsEntity> detailsEntities = detailsService.selectVByTrustNo(trustNo);
            if (!CollectionUtils.isEmpty(detailsEntities)) {
                Map<String, Integer> originValueKeyMap = detailsEntities.stream().collect(Collectors.toMap(DataDictionaryHandleTypeDetailsEntity::getOriginValue, DataDictionaryHandleTypeDetailsEntity::getDicId));
                Map<Integer, String> idKeyMap = allDatas.stream().collect(Collectors.toMap(DataDictionaryHandleTypeEntity::getId, DataDictionaryHandleTypeEntity::getKeyStr));
                originValueKeyMap.forEach((originValue, id) -> {
                    result.put(originValue, idKeyMap.get(id));
                });
            } else {
                log.error("DataDictionaryHandleTypeDetailsEntity 查询失败！");
            }
        } else {
            log.error("DataDictionaryHandleTypeEntity 查询失败！");
        }
        return result;
    }

    @Override
    public Map<String, String> queryWithDetail(DataDictionaryTypeEnum dicType, String trustNo) {
        return null;
    }

    @Override
    public R queryData(String type) {
        List<DataDictionaryHandleTypeEntity> entities = baseMapper.selectList(new QueryWrapper<>());
        if (!CollectionUtils.isEmpty(entities)) {
            return R.ok("查询字典信息成功！")
                    .put("data", entities.stream().collect(Collectors.toMap(DataDictionaryHandleTypeEntity::getKeyStr
                            ,DataDictionaryHandleTypeEntity::getValue)));
        }
        return R.ok("字典信息为空，请联系管理员配置！");
    }

}